//
//package com.locad.geometry;
//
//import com.locad.enumerations.Enumerations.MaterialTypes;
//import com.locad.enumerations.Enumerations.ShapeTypes;
//import com.locad.enumerations.Enumerations.ViewAngleModes;
//import com.locad.ldraw.ColorLibrary;
//import java.util.ArrayList;
//import java.util.Map;
//import javax.media.opengl.GL;
//
//public class LineConditional extends Shape
//{
//    public float thickness = 0;
//
//    public Point3f p1 = null;
//    public Point3f p2 = null;
//    public Point3f p3 = null;
//    public Point3f p4 = null;
//
//    public Point3f s1 = null;
//    public Point3f s2 = null;
//    public Point3f s3 = null;
//    public Point3f s4 = null;
//
//    public LineConditional()
//    {
//        super(ShapeTypes.LINE);
//    }
//
//    public static LineConditional from_Line (String input)
//    {
//        LineConditional shape = new LineConditional();
//
//        String[] tokens = input.trim().split(" ");
//        String[] t = new String[tokens.length];
//        int ndx = 0;
//        for (int i=0; i<tokens.length; i++)
//        {
//            if (tokens[i] == null ? "" != null : ! tokens[i].equals(""))
//            {
//                t[ndx] = tokens[i];
//                ndx++;
//            }
//        }
//
//        shape.colorCode = new Integer(t[1]);
//        shape.p1 = new Point3f(new Float(t[2]), new Float(t[3]), new Float(t[4]));
//        shape.p2 = new Point3f(new Float(t[5]), new Float(t[6]), new Float(t[7]));
//        shape.p3 = new Point3f(new Float(t[8]), new Float(t[9]), new Float(t[10]));
//        shape.p4 = new Point3f(new Float(t[11]), new Float(t[12]), new Float(t[13]));
//
//        return shape;
//    }
//
////    public void addToGL(GL gl, Matrix4f orientation, int requestedColorCode, ColorLibrary colorLib, boolean BFCflag)
////    {
////        Color color = getColor(requestedColorCode, renderMaterialType, colorLib);
////        if (color != null)
////        {
////            colorLib.getColor(requestedColorCode).material.ApplyToGL(gl);
////
////            s1 = new Point3D(screenX(p1.x, p1.y, p1.z), screenY(p1.x, p1.y, p1.z), 0.0);
////            s2 = new Point3D(screenX(p2.x, p2.y, p2.z), screenY(p2.y, p2.y, p2.z), 0.0);
////            s3 = new Point3D(screenX(p3.x, p3.y, p3.z), screenY(p3.y, p3.y, p3.z), 0.0);
////            s4 = new Point3D(screenX(p4.x, p4.y, p4.z), screenY(p4.y, p4.y, p4.z), 0.0);
////
////            float r1 = (s1.x - s2.x) * (s3.y - s1.y) - (s1.y - s2.y) * (s3.x - s1.x);
////            float r2 = (s1.x - s2.x) * (s4.y - s1.y) - (s1.y - s2.y) * (s4.x - s1.x);
////            if (r1 <= 0 == r2 <= 0)
////            {
////                gl.glBegin(GL.GL_LINES);
////                gl.glColor4f(color.getRed() / 255f, color.getGreen() / 255f, color.getBlue() / 255f, color.getAlpha() / 255f);
////                gl.glVertex3f(origin.x + p1.x, origin.y + p1.y, origin.z + p1.z);
////                gl.glVertex3f(origin.x + p2.x, origin.y + p2.y, origin.z + p2.z);
////                gl.glEnd();
////            }
////        }
////    }
//
//    @Override
//    public void addToGL(GL gl)
//    {
//        gl.glBegin(GL.GL_LINES);
//        gl.glColor4f(color.getRed() / 255f, color.getGreen() / 255f, color.getBlue() / 255f, color.getAlpha() / 255f);
//        gl.glVertex3f(p1.x, p1.y, p1.z);
//        gl.glVertex3f(p2.x, p2.y, p2.z);
//        gl.glEnd();
//    }
//
//    @Override
//    public void addToGLwithBFC(GL gl)
//    {
//        gl.glBegin(GL.GL_LINES);
//        gl.glColor4f(color.getRed() / 255f, color.getGreen() / 255f, color.getBlue() / 255f, color.getAlpha() / 255f);
//        gl.glVertex3f(p1.x, p1.y, p1.z);
//        gl.glVertex3f(p2.x, p2.y, p2.z);
//        gl.glEnd();
//    }
//
//    @Override
//    public void addToList(Map<MaterialTypes, ArrayList<Shape>> materials, int requestedColorCode, ColorLibrary colorLib, Matrix4f orientation, float lineWidth)
//    {
//        setColor(requestedColorCode, this.colorCode, colorLib);
//
//        thickness = lineWidth;
//        p1 = orientation.times(p1);
//        p2 = orientation.times(p2);
//
//        for (MaterialTypes materialType : material.materialTypes)
//            materials.get(materialType).add(this);
//    }
//
//    @Override
//    public void addToListBFC(Map<MaterialTypes, ArrayList<Shape>> materials, int requestedColorCode, ColorLibrary colorLib, Matrix4f orientation, float lineWidth, boolean BFCflag)
//    {
//        setColor(requestedColorCode, this.colorCode, colorLib);
//
//        thickness = lineWidth;
//        p1 = orientation.times(p1);
//        p2 = orientation.times(p2);
//
//        for (MaterialTypes materialType : material.materialTypes)
//            materials.get(materialType).add(this);
//    }
//
//    @Override
//    public Point3f getCentroid (Matrix4f orientation, Point3f minPoint, Point3f maxPoint)
//    {
//        Point3f temp1 = orientation.times(p1);
//        Point3f temp2 = orientation.times(p2);
//
//        if (temp1.x < minPoint.x)
//            minPoint.x = temp1.x;
//        if (temp1.x > maxPoint.x)
//            maxPoint.x = temp1.x;
//        if (temp1.y < minPoint.y)
//            minPoint.y = temp1.y;
//        if (temp1.y > maxPoint.y)
//            maxPoint.y = temp1.y;
//        if (temp1.z < minPoint.z)
//            minPoint.z = temp1.z;
//        if (temp1.z > maxPoint.z)
//            maxPoint.z = temp1.z;
//
//        if (temp2.x < minPoint.x)
//            minPoint.x = temp2.x;
//        if (temp2.x > maxPoint.x)
//            maxPoint.x = temp2.x;
//        if (temp2.y < minPoint.y)
//            minPoint.y = temp2.y;
//        if (temp2.y > maxPoint.y)
//            maxPoint.y = temp2.y;
//        if (temp2.z < minPoint.z)
//            minPoint.z = temp2.z;
//        if (temp2.z > maxPoint.z)
//            maxPoint.z = temp2.z;
//
//        return new Point3f(maxPoint.x - (maxPoint.x - minPoint.x) / 2f, maxPoint.y - (maxPoint.y - minPoint.y) / 2f, maxPoint.z - (maxPoint.z - minPoint.z) / 2f);
//    }
//
//    @Override
//    public boolean contains (float x, float y, ViewAngleModes viewAngle)
//    {
//        float t = thickness / 2f;
//        Point3f q1 = new Point3f(p1.x - t, p1.y - t, p1.z - t);
//        Point3f q2 = new Point3f(p2.x - t, p2.y - t, p2.z - t);
//        Point3f q3 = new Point3f(p2.x + t, p2.y + t, p2.z + t);
//        Point3f q4 = new Point3f(p1.x + t, p1.y + t, p1.z + t);
//
//        int crossings = 0;
//
//        if(viewAngle == ViewAngleModes.FRONT || viewAngle == ViewAngleModes.BACK)
//        {
//            if (((q1.y <= y) && (y < q2.y) || (q2.y <= y) && (y < q1.y)) && x < ((q2.x - q1.x) / (q2.y - q1.y)) * (y - q1.y) + q1.x)
//                crossings++;
//            if (((q2.y <= y) && (y < q3.y) || (q3.y <= y) && (y < q2.y)) && x < ((q3.x - q2.x) / (q3.y - q2.y)) * (y - q2.y) + q2.x)
//                crossings++;
//            if (((q3.y <= y) && (y < q4.y) || (q4.y <= y) && (y < q3.y)) && x < ((q4.x - q3.x) / (q4.y - q3.y)) * (y - q3.y) + q3.x)
//                crossings++;
//            if (((q4.y <= y) && (y < q1.y) || (q1.y <= y) && (y < q4.y)) && x < ((q1.x - q4.x) / (q1.y - q4.y)) * (y - q4.y) + q4.x)
//                crossings++;
//        }
//        else if(viewAngle == ViewAngleModes.LEFT || viewAngle == ViewAngleModes.RIGHT)
//        {
//            if (((q1.y <= y) && (y < q2.y) || (q2.y <= y) && (y < q1.y)) && x < ((q2.z - q1.z) / (q2.y - q1.y)) * (y - q1.y) + q1.z)
//                crossings++;
//            if (((q2.y <= y) && (y < q3.y) || (q3.y <= y) && (y < q2.y)) && x < ((q3.z - q2.z) / (q3.y - q2.y)) * (y - q2.y) + q2.z)
//                crossings++;
//            if (((q3.y <= y) && (y < q4.y) || (q4.y <= y) && (y < q3.y)) && x < ((q4.z - q3.z) / (q4.y - q3.y)) * (y - q3.y) + q3.z)
//                crossings++;
//            if (((q4.y <= y) && (y < q1.y) || (q1.y <= y) && (y < q4.y)) && x < ((q1.z - q4.z) / (q1.y - q4.y)) * (y - q4.y) + q4.z)
//                crossings++;
//        }
//        else if(viewAngle == ViewAngleModes.TOP || viewAngle == ViewAngleModes.BOTTOM)
//        {
//            if (((q1.z <= y) && (y < q2.z) || (q2.z <= y) && (y < q1.z)) && x < ((q2.x - q1.x) / (q2.z - q1.z)) * (y - q1.z) + q1.x)
//                crossings++;
//            if (((q2.z <= y) && (y < q3.z) || (q3.z <= y) && (y < q2.z)) && x < ((q3.x - q2.x) / (q3.z - q2.z)) * (y - q2.z) + q2.x)
//                crossings++;
//            if (((q3.z <= y) && (y < q4.z) || (q4.z <= y) && (y < q3.z)) && x < ((q4.x - q3.x) / (q4.z - q3.z)) * (y - q3.z) + q3.x)
//                crossings++;
//            if (((q4.z <= y) && (y < q1.z) || (q1.z <= y) && (y < q4.z)) && x < ((q1.x - q4.x) / (q1.z - q4.z)) * (y - q4.z) + q4.x)
//                crossings++;
//        }
//
//        if (crossings % 2 != 0)
//        {
//            return true;
//        }
//        return false;
//    }
//
//    public LineConditional copy()
//    {
//        LineConditional that = new LineConditional();
//
//        that.color = this.color;
//        that.colorCode = this.colorCode;
//        that.material = this.material.copy();
//        that.p1 = this.p1.copy();
//        that.p2 = this.p2.copy();
//
//        return that;
//    }
//
//    @Override
//    public String toString ()
//    {
//        StringBuilder strBuffer = new StringBuilder();
//
//        strBuffer.append(super.toString()).append("\n");
//        strBuffer.append("p1 ").append(p1).append("\n");
//        strBuffer.append("p2 ").append(p2).append("\n");
//
//        return strBuffer.toString();
//    }
//}
