
package com.locad.model;

import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.util.Enumeration;

public class RandomID
{
    public RandomID ()
    {
        try
        {
            random = SecureRandom.getInstance("SHA1PRNG");

            Enumeration<NetworkInterface> interfaces = NetworkInterface.getNetworkInterfaces();
            for (; interfaces.hasMoreElements();)
            {
                Enumeration<InetAddress> addresses = interfaces.nextElement().getInetAddresses();
                for (; addresses.hasMoreElements();)
                    value += addresses.nextElement().getHostAddress() + ":";
            }

            value += Long.toString(System.currentTimeMillis());
            value += ":";
            value += random.nextInt();

            valueAfterMD5 = Hash.getInstance().MD5(value);
            valueAfterSHA1 = Hash.getInstance().SHA1(value);
            valueAfterSHA256 = Hash.getInstance().SHA256(value);
            fourCharacter = valueAfterMD5.substring(valueAfterMD5.length() - 4);
        }
        catch (NoSuchAlgorithmException ex)
        {
        }
        catch (SocketException ex)
        {
        }
    }
    public String value = "";
    public String valueAfterMD5 = "";
    public String valueAfterSHA1 = "";
    public String valueAfterSHA256 = "";
    public String fourCharacter = "";
    private SecureRandom random;
}
